/*
Project name: Software Interrupt with LCD.
Programmer: Mir Mehedi Hasan
Starting Date: 04-Nov-2016
PIC: 16F877A
Xtal: 8Mhz
Email: mahedi.siu@gmail.com
Cell: +880 01912 463 248
*/

char boot[] = "System is booting...";
char ready[] = "System is Ready";

// Lcd pinout settings
sbit LCD_RS at RB1_bit;
sbit LCD_EN at RB2_bit;
sbit LCD_D4 at RB3_bit;
sbit LCD_D5 at RB4_bit;
sbit LCD_D6 at RB5_bit;
sbit LCD_D7 at RB6_bit;

// Pin direction
sbit LCD_RS_Direction at TRISB1_bit;
sbit LCD_EN_Direction at TRISB2_bit;
sbit LCD_D4_Direction at TRISB3_bit;
sbit LCD_D5_Direction at TRISB4_bit;
sbit LCD_D6_Direction at TRISB5_bit;
sbit LCD_D7_Direction at TRISB6_bit;
  // End LCD module connections
 unsigned char *text;

 unsigned int timer=0;

void Delay_500() {
    Delay_ms(500);
}

void Delay_1000() {
    Delay_ms(1000);
}

void Clear_lcd() {
    Lcd_Cmd(_LCD_CLEAR);               // Clear display
}

void LCD_check()
{
  Lcd_Init();                        // Initialize LCD
  Lcd_Cmd(_LCD_CLEAR);               // Clear display
  Lcd_Cmd(_LCD_CURSOR_OFF);          // Cursor off
  clear_lcd();                       // Clear display

  Lcd_Out(1,1,boot);
  Delay_1000();                        //Should be 5000 ms
  clear_lcd();
  Lcd_Out(1,1,ready);
  Delay_1000();                        //Should be 5000 ms

  clear_lcd();                       // Clear display
}

void PIN_config()
{
  TRISA = 0b00000001;                                // B0 Input
  TRISB = 0b00000000;                               // All output
  TRISC = 0b11111111;                               // All Input
  TRISD = 0b00000000;                               // All output

  PORTA = 0x00;                                     // PortB Clear
  PORTB = 0x00;                                     // PortB Clear
  PORTC = 0x00;                                     // PortB Clear
  PORTD = 0x00;                                     // PortB Clear

  Delay_1000();                                      // Initializationg Delay
}

void blink_led()
{
         PORTB.F0 = ~ PORTB.F0;
         PORTD.F0 = ~ PORTD.F0;
}

//Timer1
//Prescaler 1:4; TMR1 Preload = 15536; Actual Interrupt Time : 100 ms

void InitTimer1(){
  T1CON         = 0x21;
  TMR1IF_bit         = 0;
  TMR1H         = 0x3C;
  TMR1L         = 0xB5;
  TMR1IE_bit         = 1;
  INTCON         = 0xC0;
}

void Interrupt(){
  if (TMR1IF_bit){
    TMR1IF_bit = 0;
    TMR1H         = 0x3C;
    TMR1L         = 0xB5;

    ++timer;
    if(timer==10)                  // 10*100 = 1000ms = 1s
    {
         blink_led();               // Call the LED blinking function
         timer = 0;                 // Reset the Timer variable
    }
 }
}

void main() {
// Pin Configuration

   PIN_config();

// LCD Configuration
  LCD_check();
   InitTimer1() ;
  while(1)              // Endless Loop
  {
      clear_lcd();
      Lcd_Out(1,1,"Interrupt");
      Lcd_Out(2,1,"For 1s");
      Delay_ms(5000);
  }
}